## Mirador Video Annotation POC

### What is this repository

This is a [Mirador](https://projectmirador.org/) based application that provides video annotation edition features :

+ [x] Video rendering in mirador base on the work of [Tokyo university](https://github.com/2SC1815J/mirador)
+ [x] Annotation persistance using [annotot](https://github.com/PenguinParadigm/annotot)
+ [x] Manifest storage and persistance
+ [-] Annotation on video (currently only working on images) 
+ [ ] Multi user and per-user workspace

### Requirements

+ [docker](https://docs.docker.com/)
+ [docker-compose](https://docs.docker.com/compose/install/)

This readme assumes that you now a few basic about `docker` and `docker-compose`, if you are not familliar with `docker-compose` we recommand to read [the documentation](https://docs.docker.com/compose/) first.

### Install

Clone the current git repository and cd inside.


*NOTE : the two following steps should become obsolete at some point*

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
git submodule init && git submodule update
bash build_deps.sh
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Copy `.env.template` to `.env` and change variables to suit your need.

You **MUST** set at least the `ANNOTOT_SECRET_KEY_BASE` to a random string, the rest is preconfigured for a local development environment.

The `$HTTP_FOLDER` (`./www` by default) directory will be accessible via HTTP at `http://localhost:$PORT/data` and can be used to store manifests and theirs ressources and see them in Mirador.  

Run `docker-compose up -d`, which will serve a mirador instance at `http://localhost:$DEV_PORT` (default port is 9000) with live rebuild/reload enabled on each `src/` and `public/` files modifications.

### Production

For production, one **also** need to setup :

+ `COMPOSE_FILE` should be at least `docker-compose.yml`
+ `ANNOTOT_ENV` should be `production`
+ `ANNOTOT_HOST` should be the public hostname of your annotot server

Run `docker-compose up -d`, which will serve a mirador instance at `http://localhost:$PORT` (default port is 8080).

If sources files are modified, run `docker-compose up -d --build` to update Mirador  

#### Traefik

We provide a `traefik.yml` file to use behind [traefik](https://traefik.io/) this file does the following assumptions :

+ A traefik container exists and is running in an external docker network called `traefik`
+ Traefik has a tls resolver called `myresolver`
+ Traefik has a middleware called `hardening@docker` that adds the usual security headers
